/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package TestPackage;

import Java2OWL.J2OIndividualManager;
import Java2OWL.J2OSynchroniser;
import Java2OWL.J2OWLClass;
import Java2OWL.J2OWLProperty;

 

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashSet;
import java.util.Set;  
   
/** 
 *
 * @author ohlbach  
 */

@J2OWLClass(name = "Person", OWLSuperClasses = "LivingThing")
public class TestPerson {
    boolean male; 
    String name;
    float hight;
    
    TestAddress address;
    Set<TestPerson> friends = new HashSet<TestPerson>();
  
    
    public TestPerson(boolean male, String name, TestAddress address, float hight) {
        this.male = male;
        this.name = name;
        this.address = address;
        this.hight = hight;} 
    
    public TestPerson() {}
    
    @J2OWLProperty(setter = "setGender", total=true)
    public boolean isMale() {return male;}
    
    public void setGender(boolean male) {
        this.male = male;}
    
    @J2OWLProperty(name = "hasName", total=true, setter="setName")
    public String getName() {return name;}
    
    
    public void setName(String name) {
        
        this.name = name;
    }
    @J2OWLProperty(name = "isTall",  setter="setHight")
    public float getHight() {return hight;}
    
    
    public void setHight(float hight) {
        //if(j2OWLIndividualManager != null && !j2OWLNoSynchronizationByObject) j2OWLIndividualManager.exchangePropertyValue(this, TestPerson.class.getDeclaredMethods()[6], getHight(), hight);
        this.hight = hight;
    }  
    
    
    
    @J2OWLProperty(local = true, atmost = 5, adder="addFriend", remover="removeFriend")
    public Set<TestPerson> hasFriends() {return friends;} 
    
    public void addFriend(TestPerson friend) {
        friends.add(friend);}
    
    public void removeFriend(TestPerson friend) {
        friends.remove(friend);}
     
    //public static J2OIndividualManager j2OWLIndividualManager;
    //public boolean j2OWLNoSynchronizationByObject;

    
    @J2OWLProperty(name="hasAddress",setter="setAddress")
    public TestAddress getAddress() {
        return address;}
    
    public void setAddress(TestAddress address) {
        
        this.address = address;  
    } 
   
    
    @Override
    public String toString() {
        String addr = (address == null) ? "unknown" : address.toString();
        String s = "Person " + name + "("+(male? "m" : "w")+") "+ addr + "\nFriends: ";
        for(TestPerson person : friends) s += person.getName() + ", ";
        return s;}
    
    @Override
    public boolean equals(Object object) {
        TestPerson person = (TestPerson)object;
        return address.equals(person.address) && name.equals(person.name) && male == person.male;
    }
    public static void main(String[] args  ) throws NoSuchMethodException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
        System.out.println("TestPerson main");
        Object tp = new TestPerson();
        Object ad = new TestAddress();
        Method setter = TestPerson.class.getMethod("setAddress", TestPackage.TestAddress.class);
        setter.invoke(tp,ad);
        System.out.println("END " + tp.getClass() + " " + ad.getClass() + "  " + setter);
        
    }
}
