/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package TestPackage;

import Java2OWL.J2OWLClass;
import Java2OWL.J2OWLProperty;
 
/** 
 *
 * @author ohlbach
 */  
@J2OWLClass(name = "Student") 
public class TestStudent extends TestPerson {  
    byte semester;
    double mark;
    TestStudyProgramme programme = null;
    
    public TestStudent() {}     
    
    public TestStudent(boolean male, String name, TestAddress address, float hight) {
        super(male,name,address,hight);
        semester = 1;
        mark = 0;  
    }
    
    @J2OWLProperty(name = "studies", setter = "setProgramme")
    public TestStudyProgramme getProgramme() {return programme;}
    
    public void setProgramme(TestStudyProgramme programme) {
        this.programme = programme;}
    
    @J2OWLProperty(name = "semester", setter = "setSemester")
    public byte getSemester() {return semester;}
    
    public void setSemester(byte semester) {
        this.semester = semester;} 
    
    public void incSemester() {
        setSemester((byte)(semester+1));}
    
    @J2OWLProperty(name = "mark", setter = "setMark")
    public double getMark() {return mark;}
    
    public void setMark(double mark) {this.mark = mark;}
    
    
  
    @Override
    public String toString() {
        String s = super.toString() + "\n";
        if(programme != null) s += programme.getName() + "(" + semester +")" + " Mark: " + mark;
        return s;
    }
    
    @Override
    public boolean equals(Object object) {
        if(!super.equals(object)) return false;
        TestStudent person = (TestStudent)object;
        return semester == person.semester && mark == this.mark;
    }
    public static void main(String[] args) {   
        
    }
}
